*+
*+
*+    Source Module => D:\ALASKA\NATIVE\Tabpage\DEMOTAB.PRG
*+
*+    Functions: Procedure appsys()
*+               Procedure Main()
*+               Procedure MainResize()
*+
*+    Reformatted by Click! 2.03 on Sep-7-2018 at 12:09 am
*+
*+

#include "xbp.ch"
#include "Appevent.ch"

*+
*+
*+    Procedure appsys()
*+
*+
*+
PROCEDURE appsys

RETURN

*+
*+
*+    Procedure Main()
*+
*+
*+
PROCEDURE Main()

   LOCAL nEvent, oXbp, mp1, mp2
   LOCAL oDlg, oTabCtl
   LOCAL aSize  := { 640, 480 }
   LOCAL lExit  := .F.

   SET DATE GERMAN
   SET EPOCH TO YEAR( DATE() ) - 50
   SET CENTURY OFF

   oDlg := XBPDIALOG() :New( APPDESKTOP(),, { 0, 0 }, aSize,, .F. )
   oDlg:taskList := .T.
   oDlg:title := "native TabControl"
   oDlg:icon := 1
   oDlg:close := { || lExit := .T. }
   oDlg:drawingArea:resize := { | aOldSize, aNewSize, oSelf | MainResize( aOldSize, aNewSize, oSelf ) }
   oDlg:Create()
   oDlg:drawingArea:ClipChildren := .T.

   // create Tab-Control and Tab-Pages
   //
   oTabCtl := CreateTabs( oDlg )

   CenterControl( oDlg )
   oDlg:Show()
   SETAPPFOCUS( oDlg )

   // resize all Tab Bodys
   //
   // MainResize Childlist() of Tab Bodys
   //
   aSize := oDlg:drawingArea:currentSize()
   PostAppEvent( xbeP_Resize, { 1, 1 }, aSize, oDlg:drawingArea )

   nEvent := xbe_None
   DO WHILE !lExit
      nEvent := APPEVENT( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         EXIT
      ENDIF
   ENDDO

   oTabCtl:destroy()
   oDlg:destroy()

RETURN

*+
*+
*+    Procedure MainResize()
*+
*+    Called from ( demotab.prg  )   1 - procedure main()
*+
*+
*+
PROCEDURE MainResize( aOldSize, aNewSize, oSelf )

   LOCAL aChild1
   LOCAL i, iMax
   LOCAL aBody
   LOCAL j, jMax
   LOCAL aChild2
   LOCAL k, kMax
   LOCAL aRect   := { 0, 0, 0, 0 }
   LOCAL aSize
   LOCAL oTabCtl
   LOCAL nHigh
   LOCAL nWide
   LOCAL nRow

   IF aOldSize[ 1 ] == 0 .AND. aOldSize[ 2 ] == 0           // Size = 0
      aOldSize := aNewSize                                  // old = new
   ELSEIF aNewSize[ 1 ] == 0 .OR. aNewSize[ 2 ] == 0        // Size = 0
      RETURN
      // add "same Size", nothing had happend
   ELSEIF aNewSize[ 1 ] = aOldSize[ 1 ] .AND. aNewSize[ 2 ] = aOldSize[ 2 ]
      RETURN
   ENDIF

   oSelf:lockUpdate( .T. )

   // here only DXE_TabCtl on hole oSelf:DrawingAreas
   //
   aChild1 := oSelf:childList()
   iMax := LEN( aChild1 )
   FOR i := 1 TO iMax

      IF aChild1[ i ] :isDerivedFrom( "DXE_TabCtl" )
         oTabCtl := aChild1[ i ]

         // DXE_TabCtl : only TAB Control, not "Body" nere
         //
         oTabCtl:SetposandSize( { 10, 10 }, { aNewSize[ 1 ] - 20, aNewSize[ 2 ] - 20 } )

         // adjust all Tab Bodys by oTabCtl:BodyResize()
         //
         oTabCtl:BodyResize( { 1, 1 }, { aNewSize[ 1 ] - 20, aNewSize[ 2 ] - 20 }, oTabCtl )

         // Tab Control "Bodys"
         //
         aBody := oTabCtl:childList()

         jMax := LEN( aBody )
         FOR j := 1 TO jMax

            // XbParts on each Tab Body
            //
            aChild2 := aBody[ j ] :childList()
            aSize   := aBody[ j ] :Currentsize()

            kMax := LEN( aChild2 )
            FOR k := 1 TO kMax
               DO CASE
                  CASE aChild2[ k ] :isDerivedFrom( "XbpPushbutton" )
                     aChild2[ k ] :SetposandSize( { 10, 10 }, { aSize[ 1 ] - 20, aSize[ 2 ] - 20 } )

                  CASE aChild2[ k ] :isDerivedFrom( "XbpDialog" )
                     aChild2[ k ] :SetposandSize( { 10, 10 }, { aSize[ 1 ] - 20, aSize[ 2 ] - 20 } )
               ENDCASE
            NEXT
         NEXT
      ENDIF
   NEXT

   oSelf:lockUpdate( .F. )
   oSelf:invalidateRect()

RETURN

*+ EOF: DEMOTAB.PRG
