
#include "common.ch"
#include "xbp.CH"
#include "Appevent.ch"

*+
*+
*+    Procedure AddProperty()
*+
*+    Called from ( usetab.prg   )   1 - function createtabs()
*+
*+
*+
PROCEDURE AddProperty( oDraw, oTabCtl )

   LOCAL oThread := Thread() :new()
   oThread:start( "DlgProperty", oDraw, oTabCtl )
RETURN

*+
*+
*+    Procedure DlgProperty()
*+
*+
*+
PROCEDURE DlgProperty( oDraw, oTabCtl )

   LOCAL nEvent, oXbp, mp1, mp2
   LOCAL oDlg
   LOCAL lExit  := .F.
   LOCAL oMain  := oTabCtl:Setparent()

   oDlg := PropDlg() :New( oDraw )
   oDlg:titlebar := .F.
   oDlg:border := XBPDLG_NO_BORDER
   oDlg:close := { || lExit := .T. }
   oDlg:drawingArea:resize := { | aOldSize, aNewSize, oSelf | PropertyResize( aOldSize, aNewSize, oSelf ) }

   oDlg:ButtonOK:activate := { || oTabCtl:UpdateStyle( .F. ), ;
                                  oDlg:GetMarkStyle( oTabCtl ), ;
                                  oTabCtl:SetStyle(), ;
                                  oTabCtl:UpdateStyle( .T. ), ;
                                  PostAppEvent( xbeP_Resize, { 1, 1 }, oMain:Currentsize(), oMain ) }
   oDlg:Create()
   oDlg:Show()
   CenterControl( oDlg, oDraw )

   oDlg:FillForm( oTabCtl )

   PostAppEvent( xbeP_Resize, { 1, 1 }, oMain:Currentsize(), oMain )

   nEvent := xbe_None
   DO WHILE !lExit
      nEvent := APPEVENT( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT                                               // AppQuit()
      ENDIF
   ENDDO

   oDlg:Destroy()

RETURN

*+
*+
*+    Class PropForm
*+
*+
*+
CLASS PropForm FROM XbpDialog

   EXPORTED:
      VAR editControls

      VAR oGrpAll
      VAR oStyle
      VAR oAlignment
      VAR oJustify
      VAR oGrpMulti
      VAR oMulti
      VAR oVertical
      VAR oGrpFlat
      VAR oFlatbutton
      VAR oSeparators
      VAR oGrpLabel
      VAR oLabelleft
      VAR oScrollLoop
      VAR ButtonOK
      VAR ButtonCancel

      METHOD INIT
      METHOD CREATE
ENDCLASS

*+
*+
*+    Method PropForm:init()
*+
*+
*+
METHOD PropForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   LOCAL aDraw

   DEFAULT oParent  TO APPDESKTOP(), ;
           aPos     TO { 0, 0 }, ;
           aSize    TO { 426, 180 }, ;
           lVisible TO .T.

   DEFAULT aPP TO {}
   AADD( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "Neues Formular"

   aDraw := ::XbpDialog:drawingArea:CurrentSize()

   ::editControls := {}

   ::oGrpAll := XBPSTATIC() :new( ::drawingArea,, { 0, 0 }, aDraw,, .T. )
   ::oGrpAll:caption := "Style Property"
   ::oGrpAll:clipSiblings := .T.
   ::oGrpAll:type := XBPSTATIC_TYPE_GROUPBOX

   ::oStyle       := XBPCOMBOBOX() :new( ::oGrpAll,, { 16, 84 + 10 }, { 128, 60 }, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oStyle:tabStop := .T.
   ::oStyle:type  := XBPCOMBO_DROPDOWNLIST

   ::oAlignment   := XBPCOMBOBOX() :new( ::oGrpAll,, { 148, 84 + 10 - 60 }, { 128, 120 }, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oAlignment:tabStop := .T.
   ::oAlignment:type := XBPCOMBO_DROPDOWNLIST

   ::oJustify     := XBPCOMBOBOX() :new( ::oGrpAll,, { 280, 84 + 10 - 30 }, { 128, 90 }, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oJustify:tabStop := .T.
   ::oJustify:type := XBPCOMBO_DROPDOWNLIST

   ::oGrpMulti    := XBPSTATIC() :new( ::oGrpAll,, { 148, 68 }, { 128, 64 }, { { XBP_PP_BGCLR, - 255 } } )
   ::oGrpMulti:caption := ""
   ::oGrpMulti:clipSiblings := .T.
   ::oGrpMulti:type := XBPSTATIC_TYPE_GROUPBOX

   ::oMulti := XBPCHECKBOX() :new( ::oGrpMulti,, { 4, 24 }, { 100, 20 } )
   ::oMulti:caption := "MultiRow"
   ::oMulti:tabStop := .T.
   ::oMulti:selected := { || NIL }

   ::oVertical := XBPCHECKBOX() :new( ::oGrpMulti,, { 4, 4 }, { 100, 20 } )
   ::oVertical:caption := "Vertical"
   ::oVertical:tabStop := .T.
   ::oVertical:selected := { || NIL }

   ::oGrpFlat     := XBPSTATIC() :new( ::oGrpAll,, { 16, 68 }, { 128, 64 }, { { XBP_PP_BGCLR, - 255 } } )
   ::oGrpFlat:caption := ""
   ::oGrpFlat:clipSiblings := .T.
   ::oGrpFlat:type := XBPSTATIC_TYPE_GROUPBOX

   ::oFlatbutton := XBPCHECKBOX() :new( ::oGrpFlat,, { 4, 24 }, { 100, 20 } )
   ::oFlatbutton:caption := "Flatbutton"
   ::oFlatbutton:tabStop := .T.
   ::oFlatbutton:selected := { || NIL }

   ::oSeparators := XBPCHECKBOX() :new( ::oGrpFlat,, { 4, 4 }, { 100, 20 } )
   ::oSeparators:caption := "Separators"
   ::oSeparators:tabStop := .T.
   ::oSeparators:selected := { || NIL }

   ::oGrpLabel    := XBPSTATIC() :new( ::oGrpAll,, { 280, 68 }, { 128, 64 }, { { XBP_PP_BGCLR, - 255 } } )
   ::oGrpLabel:caption := ""
   ::oGrpLabel:clipSiblings := .T.
   ::oGrpLabel:type := XBPSTATIC_TYPE_GROUPBOX

   ::oLabelleft := XBPCHECKBOX() :new( ::oGrpLabel,, { 4, 24 }, { 100, 20 } )
   ::oLabelleft:caption := "Labelleft"
   ::oLabelleft:tabStop := .T.
   ::oLabelleft:selected := { || NIL }

   ::oScrollLoop := XBPCHECKBOX() :new( ::oGrpLabel,, { 4, 4 }, { 100, 20 } )
   ::oScrollLoop:caption := "ScrollLoop"
   ::oScrollLoop:tabStop := .T.
   ::oScrollLoop:selected := { || NIL }

   ::ButtonOK     := XBPPUSHBUTTON() :new( ::oGrpAll,, { 280, 16 }, { 128, 40 }, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, - 58 } } )
   ::ButtonOK:caption := "~Save"
   ::ButtonOK:tabStop := .T.
   ::ButtonOK:activate := { || Gather( ::editControls ), PostAppEvent( xbeP_Close ) }

   ::ButtonCancel := XBPPUSHBUTTON() :new( ::oGrpAll,, { 16, 12 }, { 128, 44 }, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, - 58 } } )
   ::ButtonCancel:caption := "~Abort"
   ::ButtonCancel:tabStop := .T.
   ::ButtonCancel:activate := { || PostAppEvent( xbeP_Close ) }

RETURN self

*+
*+
*+    Method PropForm:create()
*+
*+
*+
METHOD PropForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oGrpAll:create()
   ::oStyle:create()
   ::oAlignment:create()
   ::oJustify:create()
   ::oGrpMulti:create()
   ::oMulti:create()
   ::oVertical:create()
   ::oGrpFlat:create()
   ::oFlatbutton:create()
   ::oSeparators:create()
   ::oGrpLabel:create()
   ::oLabelleft:create()
   ::oScrollLoop:create()
   ::ButtonOK:create()
   ::ButtonCancel:create()

RETURN self

*+
*+
*+    Class PropDlg
*+
*+
*+
CLASS PropDlg FROM PropForm

   EXPORTED:
      METHOD INIT
      METHOD CREATE

      METHOD FillForm()
      METHOD GetMarkStyle()
ENDCLASS

*+
*+
*+    Method PropDlg:init()
*+
*+
*+
METHOD PropDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::PropForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

*+
*+
*+    Method PropDlg:create()
*+
*+
*+
METHOD PropDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::PropForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

*+
*+
*+    Method PropDlg:FillForm()
*+
*+
*+
METHOD PropDlg:FillForm( oTabCtl )

   LOCAL nNo
   LOCAL xValue := 0

   ::oMulti:selected := { | lCheck, uNIL, oSelf | oTabCtl:lMulti := lCheck, ;
                          IF( lCheck, NIL, ::oVertical:Setdata( .F. ) ), ;
                          IF( lCheck, NIL, ::oAlignment:Setdata( { 1 } ) ) }

   ::oVertical:selected := { | lCheck, uNIL, oSelf | oTabCtl:lVertical := lCheck, ;
                             IF( lCheck, ::oAlignment:Setdata( { 3 } ), ::oAlignment:Setdata( { 1 } ) ), ;
                             oTabCtl:lMulti := .T., ;
                             PostAppEvent( xbeLB_ItemMarked,,, ::oAlignment ) }

   ::oFlatbutton:selected := { | lCheck, uNIL, oSelf | oTabCtl:lFlatbutton := lCheck, ;
                               IF( lCheck, ::oStyle:Setdata( { 2 } ), NIL ) }

   ::oSeparators:selected := { | lCheck, uNIL, oSelf | oTabCtl:lSeparators := lCheck, ;
                               IF( lCheck, ::oFlatbutton:setdata( .T. ), NIL ) }

   ::oLabelleft:selected := { | lCheck, uNIL, oSelf | oTabCtl:lLabelleft := lCheck }

   ::oScrollLoop:selected := { | lCheck, uNIL, oSelf | oTabCtl:lScrollLoop := lCheck }

   ::oMulti     :setData( oTabCtl:lMulti )
   ::oVertical  :setData( oTabCtl:lVertical )
   ::oFlatbutton:setData( oTabCtl:lFlatbutton )
   ::oSeparators:setData( oTabCtl:lSeparators )
   ::oLabelleft :setData( oTabCtl:lLabelleft )
   ::oScrollLoop:setData( oTabCtl:lScrollLoop )

   //--------------- 1st Combobox ---------------

   ::oStyle:addItem( "TCS_TABS" )
   ::oStyle:addItem( "TCS_BUTTONS" )

   ::oStyle:Setdata( { oTabCtl:nStyle } )
   ::oStyle:itemMarked := { | u1, u2, oSelf | nNo := oSelf:getData() [1], ;
                            IF( nNo = 1, oTabCtl:lFlatbutton := .F., NIL ), ;
                            IF( nNo = 1, ::oFlatbutton:setData( .F. ), NIL ), ;
                            oTabCtl:nStyle := nNo }

   //--------------- 2nd Combobox ---------------

   ::oAlignment:addItem( "ALIGN_TOP"    )
   ::oAlignment:addItem( "ALIGN_BOTTOM" )
   ::oAlignment:addItem( "ALIGN_LEFT"   )
   ::oAlignment:addItem( "ALIGN_RIGHT"  )

   nNo := oTabCtl:nAlignment
   DO CASE
      CASE nNo = XBPALIGN_TOP    ; xValue := 1
      CASE nNo = XBPALIGN_BOTTOM ; xValue := 2
      CASE nNo = XBPALIGN_LEFT   ; xValue := 3
      CASE nNo = XBPALIGN_RIGHT  ; xValue := 4
   OTHERWISE
      xValue := 1
   ENDCASE

   ::oAlignment:Setdata( {xValue} )
   ::oAlignment:itemMarked := { | u1, u2, oSelf | nNo := oSelf:getData() [1] , ;
                                IF( nNo = 1, xValue := XBPALIGN_TOP   , ;
                                IF( nNo = 2, xValue := XBPALIGN_BOTTOM, ;
                                IF( nNo = 3, xValue := XBPALIGN_LEFT  , ;
                                IF( nNo = 4, xValue := XBPALIGN_RIGHT , ;
                                NIL ) ) ) ), oTabCtl:nAlignment := xValue }

   //--------------- 3th Combobox ---------------

   ::oJustify:addItem( "TCS_RAGGEDRIGHT " )
   ::oJustify:addItem( "TCS_RIGHTJUSTIFY" )
   ::oJustify:addItem( "TCS_FIXEDWIDTH  " )

   ::oJustify:Setdata( { oTabCtl:nJustify } )
   ::oJustify:itemMarked := { | u1, u2, oSelf | oTabCtl:nJustify := oSelf:getData() [1] }

RETURN self

*+
*+
*+    Method PropDlg:GetMarkStyle()
*+
*+
*+
METHOD PropDlg:GetMarkStyle( oTabCtl )

   LOCAL nNo
   LOCAL xValue

   oTabCtl:nJustify     := ::oJustify   :getData() [1]
   oTabCtl:lMulti       := ::oMulti     :GetData()
   oTabCtl:lVertical    := ::oVertical  :GetData()
   oTabCtl:lFlatbutton  := ::oFlatbutton:GetData()
   oTabCtl:lSeparators  := ::oSeparators:GetData()
   oTabCtl:lLabelleft   := ::oLabelleft :GetData()
   oTabCtl:lScrollLoop  := ::oScrollLoop:GetData()

   nNo := ::oStyle:getData() [1]
   IF( nNo = 1, oTabCtl:lFlatbutton := .F., NIL )
   IF( nNo = 1, ::oFlatbutton:setData( .F. ), NIL )
   oTabCtl:nStyle := nNo

   nNo := ::oAlignment:getData() [1]
   // XBP* for TCS_* Constante
   IF( nNo = 1, xValue := XBPALIGN_TOP   , ;
   IF( nNo = 2, xValue := XBPALIGN_BOTTOM, ;
   IF( nNo = 3, xValue := XBPALIGN_LEFT  , ;
   IF( nNo = 4, xValue := XBPALIGN_RIGHT , ;
   NIL ) ) ) )
   oTabCtl:nAlignment := xValue

RETURN self

*+
*+
*+    Procedure PropertyResize()
*+
*+    Called from ( TAB10.PRG   )   1 - procedure dlgproperty()
*+
*+
*+
PROCEDURE PropertyResize( aOldSize, aNewSize, oSelf )

   LOCAL aChild1
   LOCAL i, iMax

   IF aOldSize[ 1 ] == 0 .AND. aOldSize[ 2 ] == 0           // Size = 0
      aOldSize := aNewSize                                  // old = new
   ELSEIF aNewSize[ 1 ] == 0 .OR. aNewSize[ 2 ] == 0        // Size = 0
      RETURN
      // add "same Size", nothing had happend
   ELSEIF aNewSize[ 1 ] = aOldSize[ 1 ] .AND. aNewSize[ 2 ] = aOldSize[ 2 ]
      RETURN
   ENDIF

   oSelf:lockUpdate( .T. )
   aChild1 := oSelf:childList()
   iMax := LEN( aChild1 )
   FOR i := 1 TO iMax
      // here we do not change size
      // look at MainResize()
      aChild1[ i ] :SetSize( { 426, 180 } )
      CenterControl( aChild1[ i ], oSelf )
   NEXT
   oSelf:lockUpdate( .F. )
   oSelf:invalidateRect()

RETURN

*
*
*