*+
*+
*+    Source Module => D:\ALASKA\NATIVE\Tabpage\USETAB.PRG
*+
*+    Functions: Function CreateTabs()
*+               Procedure ChildButton()
*+               Procedure AddProperty()
*+               Procedure DlgProperty()
*+               Class PropForm
*+               Method PropForm:init()
*+               Method PropForm:create()
*+               Class PropDlg
*+               Method PropDlg:init()
*+               Method PropDlg:create()
*+               Method PropDlg:FillForm()
*+               Method PropDlg:GetMark()
*+               Procedure PropertyResize()
*+
*+    Reformatted by Click! 2.03 on Sep-7-2018 at 12:09 am
*+
*+

#include "xbp.CH"
*#include "Appevent.ch"
*#include "Font.ch"

*+
*+
*+    Function CreateTabs()
*+
*+    Called from ( demotab.prg  )   1 - procedure main()
*+
*+
*+
FUNCTION CreateTabs( oDlg )

   LOCAL aPos
   LOCAL aSize
   LOCAL oDa
   LOCAL oTabCtl
   LOCAL oTab1
   LOCAL oTab2
   LOCAL oTab3
   LOCAL oTab4
   LOCAL oTab5
   LOCAL oTab6
   LOCAL oTab7
   LOCAL oTab8
   LOCAL oTab9
   LOCAL oTab10

   oDa := oDlg:DrawingArea
   aPos := { 10, 10 }
   aSize := oDa:CurrentSize()
   aSize[ 1 ] -= 20
   aSize[ 2 ] -= 20

   // this is only (Master) Tabpage Control
   //
   oTabCtl := DXE_TabCtl() :New( oDa,, aPos, aSize,, .F. )

   // use XBP* for TCS_* Constante
   //
   * oTabCtl:nAlignment := XBPALIGN_TOP                     // 0
   * oTabCtl:nAlignment := XBPALIGN_BOTTOM                  // TCS_BOTTOM
   oTabCtl:nAlignment   := XBPALIGN_LEFT                    // TCS_VERTICAL
   * oTabCtl:nAlignment := XBPALIGN_RIGHT                   // TCS_VERTICAL+TCS_RIGHT

   oTabCtl:lVertical    := .T.                              // need TCS_MULTILINE ... for left/right
   oTabCtl:lMulti       := .T.                              // TCS_MULTILINE
   oTabCtl:nStyle       := 1                                // 1=TCS_TABS,2=TCS_BUTTONS
   oTabCtl:lFlatbutton  := .F.                              // need TCS_BUTTONS
   oTabCtl:lSeparators  := .F.                              // need TCS_FLATBUTTONS
   oTabCtl:nJustify     := 2                                // 1=TCS_RAGGEDRIGHT,2=TCS_RIGHTJUSTIFY,3=TCS_FIXEDWIDTH
   oTabCtl:lLabelleft   := .T.                              // need TCS_FIXEDWIDTH -> .T.=TCS_FORCELABELLEFT,.F.=TCS_FORCEICONLEFT
   oTabCtl:lScrollLoop  := .F.                              // TCS_SCROLLOPPOSITE ... hm

   oTabCtl:Create()
   oTabCtl:Show()
   SETAPPWINDOW( oTabCtl )
   SETAPPFOCUS( oTabCtl )

   // add Tabpage here
   //
   oTab1 := oTabCtl:AddTab( "Tab1", 201 )
   oTab1:tabActivate := { || oDlg:setTitle( "native Tab1" ) }
   // just a Button as Child as Demo
   ChildButton( oTab1, "Tab1" )

   oTab2 := oTabCtl:AddTab( "Tab2", 202 )
   oTab2:tabActivate := { || oDlg:setTitle( "native Tab2" ) }
   ChildButton( oTab2, "Tab2" )
   oTab3 := oTabCtl:AddTab( "Tab3", 203 )
   oTab3:tabActivate := { || oDlg:setTitle( "native Tab3" ) }
   ChildButton( oTab3, "Tab3" )
   oTab4 := oTabCtl:AddTab( "Tab4", 204 )
   oTab4:tabActivate := { || oDlg:setTitle( "native Tab4" ) }
   ChildButton( oTab4, "Tab4" )
   oTab5 := oTabCtl:AddTab( "Tab5", 205 )
   oTab5:tabActivate := { || oDlg:setTitle( "native Tab5" ) }
   ChildButton( oTab5, "Tab5" )
   oTab6 := oTabCtl:AddTab( "Tab6", 206 )
   oTab6:tabActivate := { || oDlg:setTitle( "native Tab6" ) }
   ChildButton( oTab6, "Tab6" )
   oTab7 := oTabCtl:AddTab( "Tab7", 207 )
   oTab7:tabActivate := { || oDlg:setTitle( "native Tab7" ) }
   ChildButton( oTab7, "Tab7" )
   oTab8 := oTabCtl:AddTab( "Tab8", 208 )
   oTab8:tabActivate := { || oDlg:setTitle( "native Tab8" ) }
   ChildButton( oTab8, "Tab8" )
   oTab9 := oTabCtl:AddTab( "Tab9", 209 )
   oTab9:tabActivate := { || oDlg:setTitle( "native Tab9" ) }
   ChildButton( oTab9, "Tab9" )

   // last Tabpage special
   oTab10 := oTabCtl:AddTab( "Tab10", 210 )
   oTab10:tabActivate := { || oDlg:setTitle( "native Tab10" ) }
   // add Property Dialog
   AddProperty( oTab10, oTabCtl )

   // activate 10th Tab
   //
   oTab10:maximize()

RETURN oTabCtl

*+
*+
*+    Procedure ChildButton()
*+
*+    Called from ( usetab.prg   )   9 - function createtabs()
*+
*+
*+
PROCEDURE ChildButton( oDraw, cCaption )

   LOCAL oXbp
   LOCAL aPos  := { 10, 10 }
   LOCAL aSize := oDraw:CurrentSize()

   aSize[ 1 ] -= 20
   aSize[ 2 ] -= 40

   // Childlist() Area must be adjust by oTabCtl:BodyResize()
   //
   oXbp := XBPPUSHBUTTON() :new( oDraw,, aPos, aSize, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, - 58 } } )
   oXbp:caption := cCaption
   oXbp:create()
   oXbp:activate := { || MSGBOX( "Pushbutton " + cCaption ) }
RETURN

*+ EOF: USETAB.PRG
